<?
 require_once($_path["include"]."data.php");
 require_once($_jasPath["project"]["include"]."view.php");

 class system_statistics_backend extends BasePluginBackend
 {
  function main()
  {
   if(request("cms"))
    $this->output=$this->cms();
   else 
   {
    global $_path;
    require_once($this->plugin->path["root"]."ss.php");
 
    if(request("run"))
    {
     $ss=new SystemStatistics(request("run"));

     if(($ss->config["ssh_host"]||$ss->config["ssh_user"])&&!$ss->cli->exec("ls"))
      $this->e->add($ss->e);
     else if(!$ss->gather())
      $this->e->add($ss->e);
     else
      $this->e->add("Run succesful", "note");
    }

    $this->output.=$this->overview();
   }

   return true;
  } 

  function overview()
  {
   global $_jasPath, $path, $baseURL;

   require_once($this->plugin->path["root"]."ss.php");
   $ss=new SystemStatistics("");

   $d=new Data("system_statistics_pluginConfigs", "view", "all");
   $d->setValue("plugin", $this->plugin->name);
   $d->sortOrder("ssh_host");
   $d->get();

   $r="";

   $r.="<h3>Cron</h3>\n<ul class=\"list decimal\">";
   $r.="<li>gather.php can be found in: \"jas/".$this->plugin->path["root"]."\"</li>\n";
   $r.="<li>gather.php can be call with --all to run all configured System Statistics jobs</li>\n";
   $r.="<li>Cronjob example running all jobs every 5 minutes:<br/> */5 * * * * php ".$_SERVER["DOCUMENT_ROOT"]."/jas/".$this->plugin->path["root"]."gather.php --all</li>\n";
   $r.="<li>Make sure you run the cronjobs as the same user running the webserver when using SSH. The SSH keys are only accessible by this user.</li>\n";
   $r.="</ul><br/>\n";

   $r.="<h3>Disk temperature</h3>\n<ul class=\"list decimal\">";
   $r.="<li>Smartctl is used to gather the disk temperature. Since this program requires root access to run make sure you add the following line to the \"/etc/sudoers\" file on the applicable host(s):<br/>apache ALL=NOPASSWD:/usr/sbin/smartctl -A -i /dev/sda</li>\n";
   $r.="<li>You'll need to add a line for each disk you've configured, replacing /dev/sda with the applicable device</li>\n";
   $r.="<li>You'll need to replace \"apache\" with the user running the webserver or the SSH user connecting to the host</li>\n";
   $r.="</ul><br/>\n";
/*
   $r.="<h3>SSH</h3>\n<ul class=\"list decimal\">";
   $r.="<li>SSH is".($ss->isSSHAvailable()?"":" NOT ")." available</li>\n";
   $r.="<li>SSH is".($ss->isSSHSetup()?"":" NOT ")." set up correctly</li>\n";

   if($ss->isSSHAvailable()&&!$ss->isSSHSetup())
    $r.="<li><a href=\"".$this->plugin->url()."setupssh=1\" title=\"Setup SSH\">Setup SSH</a></li>\n";

   $r.="</ul><br/>\n";
*/

   $r.="<h2>Configurations</h2>\n";
   if($d->r("add")) $r.="<a href=\"".$this->plugin->url()."cms=1&amp;a=add&amp;m=".$d->module."&amp;plugin[0]=".$this->plugin->name."\" title=\"Add ".$d->title."\">".icon("add", $d->module)."</a><br/><br/>\n";

   $r.="<div class=\"configs\">\n";

   while($d->next())
   {
    $r.="<div class=\"config\">";
    $r.="<h3>".$d->v["key"].($d->v["ssh_host"]?" (".$d->v["ssh_host"].")":"")."</h3>";
    
    if($d->v["load"])
     $r.="<div class=\"field\"><div class=\"title\">".$d->title("load")."</div><div class=\"input\">Yes</div></div>\n";
    if($d->v["sensors"])
     $r.="<div class=\"field\"><div class=\"title\">".$d->title("sensors")."</div><div class=\"input\">".join(", ", $d->v["sensors"])."</div></div>\n";
    if($d->v["networkdevs"])
     $r.="<div class=\"field\"><div class=\"title\">".$d->title("networkdevs")."</div><div class=\"input\">".join(", ", $d->v["networkdevs"])."</div></div>\n";
    if($d->v["mounteddevices"])
     $r.="<div class=\"field\"><div class=\"title\">".$d->title("mounteddevices")."</div><div class=\"input\">".join(", ", $d->v["mounteddevices"])."</div></div>\n";
    if($d->v["smartdisks"])
     $r.="<div class=\"field\"><div class=\"title\">".$d->title("smartdisks")."</div><div class=\"input\">".join(", ", $d->v["smartdisks"])."</div></div>\n";

    $r.="<div class=\"field\"><div class=\"title\">Cron job</div><div class=\"input\">php gather.php \"".$d->v["key"]."\"</div></div>\n";

    if($d->v["ssh_host"])
     $r.="<div class=\"field\"><div class=\"title\">SSH</div><div class=\"input\">".$d->v["ssh_user"]."@".$d->v["ssh_host"].":".$d->v["ssh_port"]."</div></div>\n";

    
    $r.="<div class=\"cmsOptions\">\n";
    $r.="<a href=\"".$baseURL."?main=1&amp;config=".$d->v["key"]."\" title=\"Graph: ".$d->v["key"]."\">".icon("graph")."</a>\n";
    $r.="<a href=\"".$this->plugin->url()."run=".$d->v["key"]."\" title=\"Run: ".$d->v["key"]."\">".icon("execute")."</a>\n";
    if($d->r("edit")) $r.="<a href=\"".$this->plugin->url()."cms=1&amp;a=edit&amp;m=".$d->module."&amp;nr=".$d->v["nr"]."\" title=\"Edit: ".$d->v["key"]."\">".icon("edit", $d->module)."</a>\n";
    if($d->r("move")) $r.="<a href=\"".$this->plugin->url()."cms=1&amp;a=move&amp;m=".$d->module."&amp;nr=".$d->v["nr"]."\" title=\"Move: ".$d->v["key"]."\">".icon("move", $d->module)."</a>\n";
    if($d->r("delete")) $r.="<a href=\"".$this->plugin->url()."cms=1&amp;a=delete&amp;m=".$d->module."&amp;nr=".$d->v["nr"]."\" title=\"Delete: ".$d->v["key"]."\">".icon("delete", $d->module)."</a>\n";
    $r.="</div>\n";

    $r.="<br/><br/></div>\n";
   }

   $r.="</div>\n";

   return $r;
  }

  function cms()
  {
   global $subcat, $cat, $_jasPath;
   $cms=new CMS();

   $cms->addVar("cat", ($subcat?$subcat:$cat));
   $cms->addVar("p", $this->plugin->name);
   $cms->addVar("backend", 1);
   $cms->addVar("cms", 1);

   $tmp=new Data();

   $cms->setData($tmp);
   $r=$cms->form($_jasPath["file"]);

   return $r;
  }

 }

?>
