<?
 require_once($_path["include"]."module.php");

 class system_statistics_diskspace extends Module
 {
  function init(&$data)
  {
   global $_path;

   parent::init($data);

   $this->data->title=$this->data->l->t("Disk space system statistics");

   $this->data->addField("nr", "nr", "sql;form", "identifier;hidden");

   $this->data->addField("keynr", "nr", "all", "reload", 1, false, 0, "Device");
   $this->data->addReference("keynr", "system_statistics_keys", "nr", "*:1");

   $this->data->addField("total", "nr", "all", "big", 0, false, 0, "Total bytes");
   $this->data->addField("used", "nr", "all", "big", 0, false, 0, "Bytes used");
   $this->data->addField("available", "nr", "all", "big", 0, false, 0, "Bytes available");
   $this->data->addField("timestamp", "datetime", "all", "title", false, false, mktime(), "Timestamp");

   $this->data->addField("userrights", "rights", "", "allusers", 0, false, 256); 

   $this->data->addIndex("keynr", "keynr"); 

   $this->data->sortOrder("timestamp-", "keynr");
  }
 }
?>
