<?
 require_once($_path["include"]."module.php");

 class system_statistics_load extends Module
 {
  function init(&$data)
  {
   global $_path;

   parent::init($data);

   $this->data->title=$this->data->l->t("Load system statistics");

   $this->data->addField("nr", "nr", "sql;form", "identifier;hidden");

   $this->data->addField("keynr", "nr", "all", "reload", 1, false, 0, "Key");
   $this->data->addReference("keynr", "system_statistics_keys", "nr", "*:1");

   $this->data->addField("avgload1", "float", "all", "", 0, false, 0, "Averge load 1 minute");
   $this->data->addField("avgload5", "float", "all", "", 0, false, 0, "Averge load 5 minute");
   $this->data->addField("avgload15", "float", "all", "", 0, false, 0, "Averge load 15 minute");
   $this->data->addField("activeprocs", "nr", "all", "", 0, false, 0, "Active processes");
   $this->data->addField("totalprocs", "nr", "all", "", 0, false, 0, "Total processes");

   $this->data->addField("timestamp", "datetime", "all", "title", 0, false, mktime(), "Timestamp");
   $this->data->addField("userrights", "rights", "", "allusers", 0, false, 256); 
   
   $this->data->addIndex("keynr", "keynr"); 

   $this->data->sortOrder("timestamp-", "keynr");
  }
 }
?>
